/*Barry Kauler 2006, puppyserialdetect, for Puppy, www.puppyos.com
  Got the guts of this from Detect library, which seems to have in
  turn got it from Mandrake and/or Red Hat.
  I apologise for badly hacked code: my C knowledge is extremely rusty.*/

#include <string.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#include "detect.h"
#include "proc.h"

#ifdef MOUSE_DETECT_SERIAL
#include "serial.h"
#endif

//global settings.
unsigned char debug, detect_kbds, extendinfo, testcases, detect_PS2, detect_USB, detect_mouses
#ifdef MOUSE_DETECT_SERIAL
	, detect_on_serial
	, show_unpluged
	, force_full_scan
#endif
	;

void flagoptions(char *s){
	for (;*s!='\0';s++){
		if (*s == 'd') debug=1; //Allow for a debug setting.
		if (*s == 'k') detect_kbds=1; //Allow for a keyboard detect
		if (*s == 'm') detect_mouses=1; //Allow for a mouse detect
		if (*s == 'e') extendinfo=1; //Allow for a extended info
		if (*s == 'u') detect_USB=1; //Detect USB
		if (*s == 'p') detect_PS2=1; //Detect PS2
#ifdef MOUSE_DETECT_SERIAL
		if (*s == 's') detect_on_serial=1; //Perform detect on Serial Port serial port.
		if (*s == 'w') show_unpluged=1; //Allow for showing serial ports that exist without a device attached.
		if (*s == 'f') force_full_scan=1;
#endif
		if (*s == 't') testcases=1; //Allow for a testcases.txt file

		if (*s == '-' || *s == '?' || *s == 'h'){
#ifdef MOUSE_DETECT_SERIAL
			printf("Application to detect Mouse/Keyboard on PS2/USB/Serial\n");
			printf("and some Serial modems. Scans /proc/bus/input/devices and /dev nodes\n");
#else
			printf("Application to detect Mouse/Keyboard on PS2/USB\n");
			printf("Scans /proc/bus/input/devices\n");
#endif
			printf("    command options:\n");
			printf("        -m    detect Mouse devices\n");
			printf("        -k    detect Keyboard devices\n");
			printf("        -e    extra info like model name\n");
			printf("        -u    Detect on USB ports\n");
			printf("        -p    Detect on PS/2 ports\n");
#ifdef MOUSE_DETECT_SERIAL
			printf("        -s    Detect on Serial ports\n");
			printf("        -w    Show serial ports without device attached\n");
			printf("        -f    Force a full scan on serial ports\n");
#endif
			printf("        -d    debugging info\n");
			printf("        -t    read from 'testcases.txt' rather than \n");
			printf("              from /proc/bus/input/devices\n");
			printf("\n");
			printf("   example: ./inputdetect -kmpu\n");
			printf("            Type:USB-mouse|Port:/dev/input/mice\n");
			printf("            Type:PS2-kbd|Port:/dev/input/keyboard\n");
			printf("\n");
			printf("Original code borrowed and modified from Mandrake & Red Hat\n");
			printf("Now: inputdetect, for Puppy, www.puppylinux.com\n");
			printf("\n");
			exit(0);
		}
	}
}
int main(int argc, char *argv[]){
	int i;

	//set default options
	debug=detect_kbds=extendinfo=testcases=detect_PS2=detect_USB=detect_mouses
#ifdef MOUSE_DETECT_SERIAL
		=show_unpluged
		=detect_on_serial
		=force_full_scan

#endif
		=0;  // set to zero value.
	
	for (i=1;i<argc;i++)
		if (argv[i][0] == '-')
			flagoptions(argv[i]+1);

	if (argc == 1 ||  // if no command line options
		(detect_kbds==0 && detect_mouses==0) ||
		(
#ifdef MOUSE_DETECT_SERIAL
		detect_on_serial==0 &&
#endif 
			detect_USB==0 && detect_PS2==0)){ // if no device types to detect
		printf("NO VALID DETECT OPTIONS SELECTED\n");
		flagoptions("-?"); //Show help and exit.
	}
	
	if (debug){
		printf("%s  version %s, part of PuppySerialDetect\n", argv[0], VERSION);
		printf("Built on %s\n", __DATE__);
	}
/*if something found, stdout has format: "Type:%s|Port:%s" (mouse.c)*/
	if (detect_mouses && (detect_PS2||detect_USB))
		do_proc_detect("mouse","/dev/input/mice");
	if (detect_kbds)
		do_proc_detect("kbd","/dev/input/keyboard");
#ifdef MOUSE_DETECT_SERIAL
	if (detect_mouses && detect_on_serial)
		serial_detect();
#endif
	return 0;
}
