/*Barry Kauler 2006, puppyserialdetect, for Puppy, www.puppyos.com
  Got the guts of this from Detect library, which seems to have in
  turn got it from Mandrake and/or Red Hat.
  I apologise for badly hacked code: my C knowledge is extremely rusty.*/

#include <string.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#include "detect.h"
#include "proc.h"

#ifdef MOUSE_DETECT_SERIAL
#include "serial.h"
#endif

//global settings.
unsigned char debug, detect_kbds, extendinfo, testcases, detect_PS2, detect_USB, detect_mouses;

void flagoptions(char *s){
	for (;*s!='\0';s++){
		if (*s == 'd') debug=1; //Allow for a debug setting.
		if (*s == 'e') extendinfo=1; //Allow for a extended info
		if (*s == 't') testcases=1; //Allow for a testcases.txt file
		if (*s == '-' || *s == '?' || *s == 'h'){
			printf("Application to ONLY detect Mouse on PS2\n");
			printf("Scans /proc/bus/input/devices\n");
			printf("    command options:\n");
			printf("        -e    extra info like model name\n");
			printf("        -d    debugging info\n");
			printf("        -t    read from 'testcases.txt' rather than \n");
			printf("              from /proc/bus/input/devices\n");
			printf("\n");
			printf("Original code borrowed and modified from Mandrake & Red Hat\n");
			printf("Now: ps2mouse, for Puppy, www.puppylinux.com\n");
			printf("\n");
			exit(0);
		}
	}
}
int main(int argc, char *argv[]){
	int i;

	//set default options
	debug=detect_kbds=extendinfo=testcases=detect_PS2=detect_USB=detect_mouses=0;  // set to zero value.
	
	detect_PS2=detect_mouses=1; //Set values for this special app.
	
	for (i=1;i<argc;i++)
		if (argv[i][0] == '-')
			flagoptions(argv[i]+1);

	if ((detect_kbds==0 && detect_mouses==0) ||
		(detect_USB==0 && detect_PS2==0)){ // if no device types to detect
		printf("NO VALID DETECT OPTIONS SELECTED\n");
		flagoptions("-?"); //Show help and exit.
	}
	
	if (debug){
		printf("%s  version %s, part of PuppySerialDetect\n", argv[0], VERSION);
		printf("Built on %s\n", __DATE__);
	}
/*if something found, stdout has format: "Type:%s|Port:%s" (mouse.c)*/
	do_proc_detect("mouse","/dev/input/mice");
	return 0;
}
