/*
 * Detect a Library for hardware detection
 *
 * Copyright (C) 1998-2000 MandrakeSoft
 * Copyright (C) 2005 Alexandre Dussart
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <ctype.h>
#include <stdarg.h>
#include <sys/utsname.h>

#include "detect.h"
#include "utils.h"

/* comments have to stay there to have a translation! */
char s_unknown[] = "Unknown";


/**********************************************************************/
/* my_malloc:  Allocates size bytes and returns a pointer to the      */
/*             allocated memory.  The memory is not cleared.          */
/*             If alloc fails, aborts program with exit(-2).          */
/*     size: Number of allocated bytes.                               */
/**********************************************************************/
extern void *my_malloc(size_t size){
	void *ptr = NULL;
	if(size){
	  	if((ptr = malloc(size)) == NULL){
			fprintf(stderr, MALLOC_ERROR);
			exit(-2);
		}/*endif*/
	}
	return ptr;
}/*endfunc my_malloc*/








